<?php

function findLinkUrl($inputString) 
{

    // Search for the text link "here" in the input string
    $searchText = 'here';
    $linkUrl = '';

    // Find the position of the text link
    $position = stripos($inputString, $searchText);

    if ($position !== false) {
        // Find the href attribute by searching backward from the position of the text link
        $startPos = strrpos(substr($inputString, 0, $position), '<a');
        $endPos = strpos(substr($inputString, $position), '</a>') + $position;

        if ($startPos !== false && $endPos !== false) {
            $linkTag = substr($inputString, $startPos, $endPos - $startPos + 4);

            // Extract the URL from the href attribute
            preg_match('/href=["\'](.*?)["\']/', $linkTag, $matches);

            if (!empty($matches[1])) {
                $linkUrl = $matches[1];
            }
        }
    }

    return $linkUrl;
}



function change_to_final_url($url)
{

    // Regular expression to match URLs containing "newsnow"
    $pattern = '/\bhttps?:\/\/\S*newsnow\S*\b/';

    // Find the first "newsnow" URL in the post content
    // preg_match($pattern, $post_content, $matches);
    
    if (strpos($url, "newsnow") !== false)
    {
        echo "<br/>The word 'newsnow' is present in the string<br/>";
        $urlToGet = $url; 
        $do_only_for_this_scrape =0;
  
    include '/home/busybeerun/public_html/byjove/shared-datacenter-params.php'; 

        $final = $data;
        $urlString=findLinkUrl($final);
    
        // Define a regular expression pattern to match URLs containing the word "newsnow"
        $pattern = '/<a\s+(?:[^>]*?\s+)?href=(["\'])(.*?newsnow.*?)\1.*?<\/a>/i';
    }
    
    return $urlString;

}




function scrapeLinksAndImages($excludeFile, $urlToGet) 
{
   
    $do_only_for_this_scrape =1;
    include '/home/busybeerun/public_html/byjove/shared-datacenter-params.php';

    return $result;
}

function createHtmlPage($filename, $substring, $maxlinkstoread, $scrapedData, $outputDirectory, $topic) 
{
 
    // Determine the number of links to be displayed in each column
    $combinedString = print_r($scrapedData, true);
    
    $Links = substr_count($combinedString, $substring);
    $numLinks = strval($Links);
    $numElements = count($scrapedData);
    
    echo "numelements=".$numElements."<br/>";
    echo "Links=".$Links."<br/>";
    echo "numlinks=".$numLinks."<br/>";
    
    // Create three columns
    $htmlContent = "<!DOCTYPE html><html lang='en'><head><meta charset='UTF-8'> </head><body>";
    $PrintedUrlCount = 0;
    $linkCount = 0;
    
    $dotString = "&#133;";
      
    for ($i = 0; $i < $numElements; $i++) 
    {
        $data = $scrapedData[$i];
        $link = $data['url'];
        $linkText = $data['linkText'];
        
   


        if (strpos($link, $substring) !== false) 
        {
            
            if (strpos($linkText, $dotString) !== false) 
          
            {
                $linkText = str_replace($dotString, '...', $linkText);
            }
            
            $changed_final_url= change_to_final_url($link);
         //   $htmlContent .= "<p style='white'><a href='$changed_final_url'>{$data['linkText']}</a>";
            
             $htmlContent .= "<p style='white'><a href='$changed_final_url'>$linkText</a>";
            
         
            $htmlContent .= "<hr width=100%/></p>";
            $linkCount++;
            echo "<br/><br/>".$linkCount." changed url=".$changed_final_url."<br/><br/> Link Text=".$linkText."<br><br>";
        }

        if ($linkCount == $maxlinkstoread)
        {
            break;
        }
    }
    
    // Write the HTML content to the file
    file_put_contents($filename, $htmlContent);
    
    archive_content($topic, $htmlContent);

}

function archive_content($topic, $htmlContent)
{

    $archive_drectory = 'archive_output_html/' . $topic;
    
    /* append to archive for that topic */
    
    if (!file_exists($archive_drectory )) 
    {
        mkdir($archive_drectory , 0777, true);
    }
    
    $archive_filename= $archive_drectory . '/' . $topic . '-' . date('d-m-Y') . '.html';

    if (!file_exists( $archive_filename)) 
    {
        $filef = fopen($archive_filename, 'w');
        fclose($filef);
        echo "File created successfully:  $archive_filename";
    
    } 
    else 
    {
        echo "File already exists:  $archive_filename";
    }

    file_put_contents($archive_filename, $htmlContent, FILE_APPEND | LOCK_EX);


}



function combine_html_files($file1, $file2, $combined_file, $topic)
{

    // Read the contents of the first HTML file
    $file1_content = file_get_contents($file1);

    // Read the contents of the second HTML file
    $file2_content = file_get_contents($file2);


    // Combine the contents into a single HTML file
    $combined_content = "

    <div class='container'>
        <div class='column'>
            $file2_content
        </div>
        <div class='column'>
            $file1_content
        </div>
    </div>";

    

    // Write the combined content to a new HTML file
    file_put_contents($combined_file, $combined_content);
    
    archive_content($topic, $combined_content);

}


$topic = $_GET['TopicName'];


 $outputDirectory = 'output_html';  
 $excludeFile = 'exclude_urls.txt';     // File containing URLs to be excluded
 
switch ($topic) 
{
    
    
    case "CelebGossip" :
        $filename = $outputDirectory . '/' . 'celeb_gossip_page1.html';
        $file1 = $filename;
        
        $substring = "14436:16794";
        $urlToGet = 'https://www.newsnow.co.uk/h/Entertainment+&+Arts/Celebrity+News?type=ln';
        $maxlinkstoread = 50;
        
        $scrapedData = scrapeLinksAndImages($excludeFile,  $urlToGet);
        createHtmlPage($filename, $substring, $maxlinkstoread, $scrapedData, $outputDirectory, $topic);
        
        /* --------------------------------------------------- */
        
        $filename = $outputDirectory . '/' . 'celeb_gossip_page2.html';
        $file2 = $filename;
        
        $substring = "51508:37704";
         $urlToGet = 'https://www.newsnow.com/us/Entertainment/Celebrity+News?type=ln';

        $scrapedData = scrapeLinksAndImages($excludeFile,  $urlToGet);
        createHtmlPage($filename, $substring, $maxlinkstoread, $scrapedData, $outputDirectory, $topic);
        
        $combined_file = $outputDirectory . '/' . 'celeb_gossip_page.html';
        
        combine_html_files($file1, $file2, $combined_file, $topic);
        
        exit;
        
    break; 
    
    case "Science" :
        $filename = $outputDirectory . '/' . 'science_page.html';
        $substring = "317:218";
        $urlToGet = 'https://www.newsnow.co.uk/h/Science?type=ln';
        $maxlinkstoread = 45;
       
    break; 

    case "Tech" :
        $filename = $outputDirectory . '/' . 'tech_page.html';
        $substring = "50295:37173";
        $urlToGet = 'https://www.newsnow.com/us/Tech?type=ln';
        $maxlinkstoread = 45;

    break;       
    
    case "PremierL" :
        $filename = $outputDirectory . '/' . 'premierl_page.html';
        $substring = "1841:2178";
        $urlToGet = 'https://www.newsnow.co.uk/h/Sport/Football/Premier+League?type=ln';
        $maxlinkstoread = 45;
       
    break;     
    
    case "Relationships" :
        $filename = $outputDirectory . '/' . 'relationships_page.html';
        $substring = "55351:43403";
        $urlToGet = 'https://www.newsnow.co.uk/h/Lifestyle/Sex+&+Relationships?type=ln';
        $maxlinkstoread = 45;
    break; 
    
    case "Cricket" :
        $filename = $outputDirectory . '/' . 'cricket_page.html';
        $substring = "14437:769";
      $urlToGet = 'https://www.newsnow.co.uk/h/Sport/Cricket?type=ln';
        $maxlinkstoread = 45;
       
    break; 
    
    case "Entertainment" :
        $filename = $outputDirectory . '/' . 'entertainment_page.html';
        $substring = "50294:37172";
        $urlToGet = 'https://www.newsnow.com/us/Entertainment?type=ln';
        $maxlinkstoread = 45;
 
    break;     
    
    case "WorldNews" :
        $filename = $outputDirectory . '/' . 'world_news_page.html';
        $substring = "14432:11";
        $urlToGet = 'https://www.newsnow.co.uk/h/World+News?type=ln';
        $maxlinkstoread = 45;

    break; 

    case "Fashion" :
        $filename = $outputDirectory . '/' . 'fashion_page.html';
        $substring = "50793:37597";
        $urlToGet = 'https://www.newsnow.com/us/Entertainment/Fashion?type=ln';
        $maxlinkstoread = 45;
 
    break;     
    
    case "Cheery" :
        $filename = $outputDirectory . '/' . 'cheery_page.html';
        $substring = "495:2486375462";
        $urlToGet = 'https://www.newsnow.com/us/World/Good+News?type=ln';
        $maxlinkstoread = 45;

    break; 
    
    case "Bollywood" :
        $filename = $outputDirectory . '/' . 'bollywood_page.html';
        $substring = "13951:38127";
        $urlToGet = 'https://www.newsnow.com/us/Entertainment/Movies/Bollywood?type=ln';
        $maxlinkstoread = 45;

    break;   
    
    //-------------------------------end -----------------
    
    
     case "NewsUSA" :
        
        echo "<br>entering news usa<br>";

        $filename = $outputDirectory . '/' . 'news_usa_page.html';
        
        $substring = "15254:37150";
        $urlToGet = 'https://www.newsnow.com/us/US?type=ln';
        $maxlinkstoread = 40;
        
        
    break; 
    
    
    case "NewsUK" :
        
        echo "<br>entering news uk<br>";

        $filename = $outputDirectory . '/' . 'news_uk_page.html';
        
        $substring = "461:2192";
        $urlToGet = 'https://www.newsnow.co.uk/h/UK?type=ln';
        $maxlinkstoread = 45;
 
        
    break; 
    
    
    case "Weird" :
        $filename = $outputDirectory . '/' . 'weird_page.html';
        $substring = "11717:2486373847";
        $urlToGet = 'https://www.newsnow.com/us/World/Weird+and+Wonderful?type=ln';
        $maxlinkstoread = 50;
    break;     
    
    case "Movies" :
        $filename = $outputDirectory . '/' . 'movies_page.html';
        $substring = "50792:37601";
        $urlToGet = 'https://www.newsnow.com/us/Entertainment/Movies?type=ln';
        $maxlinkstoread = 45;
   
    break;     
    
    case "Sports" :
        $filename = $outputDirectory . '/' . 'sports_page.html';
        $substring = "15048:5";
        $urlToGet = 'https://www.newsnow.co.uk/h/Sport?type=ln';
        $maxlinkstoread = 45;

    break;     
    
    case "SportsUSA" :
        $filename = $outputDirectory . '/' . 'sports_usa_page.html';
        $substring = "50827:37801";
        $urlToGet = 'https://www.newsnow.com/us/Sports?type=ln';
        $maxlinkstoread = 100;

    break;   
    
    case "MarketsUSA" :
        $filename = $outputDirectory . '/' . 'markets_usa_page.html';
        $substring = "50948:37779";
        $urlToGet = 'https://www.newsnow.com/us/Business/Stock+Markets?type=ln';
        $maxlinkstoread = 45;
  
    break;  
    
    case "ElectionUSA" :
        $filename = $outputDirectory . '/' . 'election_usa_page.html';
        $substring = "62827:54273";
        $urlToGet = 'https://www.newsnow.com/us/Hot+Topics/2024+Presidential+Election?type=ln';
        $maxlinkstoread = 50;

    break;  
    
    case "Health" :
        $filename = $outputDirectory . '/' . 'health_page1.html';
        $file1 = $filename;
        
        $substring = "50305:37196";
        $urlToGet = 'https://www.newsnow.co.uk/h/Lifestyle/At+Home/Health+&+Fitness?type=ln';
        $maxlinkstoread = 30;
 
        
        $scrapedData = scrapeLinksAndImages($excludeFile,  $urlToGet);
        createHtmlPage($filename, $substring, $maxlinkstoread, $scrapedData, $outputDirectory);
        
        // --------------------------------------------------- 
        
        $filename = $outputDirectory . '/' . 'health_page2.html';
        $file2 = $filename;
        
        $substring = "50978:37784";
        $urlToGet = 'https://www.newsnow.com/us/Lifestyle/Health?type=ln';
        $maxlinkstoread = 40;

        $scrapedData = scrapeLinksAndImages($excludeFile,  $urlToGet);
        createHtmlPage($filename, $substring, $maxlinkstoread, $scrapedData, $outputDirectory);
        
        $combined_file = $outputDirectory . '/' . 'health_page.html';
        
        combine_html_files($file1, $file2, $combined_file);
        
        exit;
        

    case "Gaming" :
        $filename = $outputDirectory . '/' . 'gaming_page.html';
        $substring = "53869:3527582054";
        $maxlinkstoread = 50;
        $urlToGet = 'https://www.newsnow.com/us/Business/Creative+Industries/Gaming+Industry?type=ln';
    break;
    
    
    case "Music" :
        $filename = $outputDirectory . '/' . 'music_page.html';
        $substring = "50794:37599";
        $urlToGet = 'https://www.newsnow.com/us/Entertainment/Music?type=ln';
        $maxlinkstoread = 45;
    
    break;   
    
    /* ------------------------ */

    case "Autos" :
        echo "<br>entering autos<br>";
        $filename = $outputDirectory . '/' . 'autos_page.html';
        $substring = "52975:54914";
        $urlToGet = 'https://www.newsnow.com/us/Business/Automotive?type=ln';
        $maxlinkstoread = 45;
    
    break;   
    
    /* ------------------------ */
    
    case "Books" :
        echo "<br>entering books<br>";
        $filename = $outputDirectory . '/' . 'books_page.html';
        $substring = "52859:39999";
        $urlToGet = 'https://www.newsnow.com/us/Entertainment/Books?type=ln';
        $maxlinkstoread = 45;
    
    break;
    
    /* ------------------------ */

    
    case "Weather" :
        
        echo "<br>entering weather usa<br>";

        $filename = $outputDirectory . '/' . 'weather_page1.html';
        $file1 = $filename;
        
        $substring = "58577:47688";
        $urlToGet = 'https://www.newsnow.com/us/US/Weather?type=ln';
        $maxlinkstoread = 30;
    
        
        $scrapedData = scrapeLinksAndImages($excludeFile,  $urlToGet);
        createHtmlPage($filename, $substring, $maxlinkstoread, $scrapedData, $outputDirectory, $topic);
        
        /* --------------------------------------------------- */
        
         echo "<br>entering weather uk<br>";

        
        $filename = $outputDirectory . '/' . 'weather_page2.html';
        $file2 = $filename;
        
        $substring = "34607:23927";
         $urlToGet = 'https://www.newsnow.co.uk/h/UK/Weather?type=ln';
        $maxlinkstoread = 10;

        $scrapedData = scrapeLinksAndImages($excludeFile,  $urlToGet);
        createHtmlPage($filename, $substring, $maxlinkstoread, $scrapedData, $outputDirectory, $topic);
        
        $combined_file = $outputDirectory . '/' . 'weather_page.html';
        
        combine_html_files($file2, $file1, $combined_file, $topic);
        
        exit;
        
    break; 
    
    case "Travel" :
        
        
        echo "<br>entering travel uk<br>";

        $filename = $outputDirectory . '/' . 'travel_page.html';
        
        $substring = "18728:4648";
        $urlToGet = 'https://www.newsnow.co.uk/h/Lifestyle/Travel?type=ln';
        $maxlinkstoread = 40;

        
    break; 

    default :
        exit;    
        
        
        
}


if (!file_exists($outputDirectory)) 
{
    mkdir($outputDirectory, 0777, true);
}


$scrapedData = scrapeLinksAndImages($excludeFile,  $urlToGet);

    
// Create HTML page with the scraped data
createHtmlPage($filename, $substring, $maxlinkstoread, $scrapedData, $outputDirectory, $topic);


date_default_timezone_set('Europe/London');
$sTime = date("d-m-Y H:i:s");  
print 'The end time is: ' . $sTime;

?>